﻿using UnityEngine;
using System;  // Needed for Math
using System.Collections;

public class Sinus : MonoBehaviour
{
    // un-optimized version
    MDatos_cs mainDatos;
    public double frequency = 440;
    public double gain = 0.05;
    public bool cond = true;
    private double increment;
    private double phase;
    private double sampling_frequency = 48000;

    void OnAudioFilterRead(float[] data, int channels)
    {
        // update increment in case frequency has changed
        increment = frequency * 2 * Math.PI / sampling_frequency;
        for (var i = 0; i < data.Length; i = i + channels)
        {
            phase = phase + increment;
            // this is where we copy audio data to make them “available” to Unity
            data[i] = (float)(gain * Math.Sin(phase));
            // if we have stereo, we copy the mono data to each channel
            if (channels == 2) data[i + 1] = data[i];
            if (phase > 2 * Math.PI) phase = 0;
        }
    }

    void Start()
    {
        GameObject obje = GameObject.Find("DATOS_tonalidad");
        mainDatos = obje.GetComponent<MDatos_cs>();

//        print("Starting " + Time.time);
        StartCoroutine(WaitAndPrint(2.0F));
  //      print("Before WaitAndPrint Finishes " + Time.time);
    }

    void Update()
    {
       // StartCoroutine(WaitAndPrint(2.0F));

    }

    IEnumerator WaitAndPrint(float waitTime)
    {
        float nota;
        for (int i = 0; i < mainDatos.eventosL.Count; i++)
        {
            yield return new WaitForSeconds((float)0.3);
            nota = mainDatos.eventosL[i].getNota() + 12;
            frequency =Math.Pow(2,(nota-69)/12)*440;
        }
        
            //yield return new WaitForSeconds((float)UnityEngine.Random.Range(0, 50)/100);
            //frequency = (UnityEngine.Random.Range(400, 1000)) % 15000;
    }

    

}

