﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CrearCirculo : MonoBehaviour
{
    public GameObject objPentagrama;
    public GameObject textoCirculitosObj;
    private float px;
    private float py;
    private int diam;
    private int radioAcorde;
    private int radioMay;
    private int radioMen;
    List<GameObject> circulos;
    //List<GameObject> circulos;
    List<float> notasTeclado;
    Pentagrama pent;
    TextMesh textoCirculo;
    UniversoTonal univ;
    Armonia armAct;
    string tonalidadEtq;
    //public GameObject tecladoMidi;
    public Material lineasMat;

    void Start()
    {
        radioAcorde = 20;
        px = transform.position.x;
        py = transform.position.y;
        pent = objPentagrama.GetComponent<Pentagrama>();
        armAct = pent.armActual;

        //GameObject objTextCirc = GameObject.Find("TextoCirculo");
        textoCirculo = textoCirculitosObj.GetComponent<TextMesh>();
        univ = GameObject.Find("DATOS_tonalidad").GetComponent<MainDatos>().univ;
        //Debug.Log("Pent " + pent);
        //Debug.Log("Acorde " + armAct);
        textoCirculo.text = univ.gradoAcordeRomSecEscAct(armAct) + "\n" + armAct.getStringSencillo(univ.stringToEscala(pent.tonEtqAct));

        // Crear circulos
        float x, y, xt, yt;
        float ang = -2 * Mathf.PI / 12;
        circulos = new List<GameObject>();
        for (int i = 0; i < 12; i++)
        {
            x = px + radioAcorde * Mathf.Cos(i * ang + Mathf.PI / 2);
            y = py - radioAcorde * Mathf.Sin(i * ang + Mathf.PI / 2);
            xt = px + (radioAcorde + 5) * Mathf.Cos(i * ang + Mathf.PI / 2);
            yt = py - (radioAcorde + 5) * Mathf.Sin(i * ang + Mathf.PI / 2);

            GameObject wreckClone = (GameObject)Instantiate(textoCirculitosObj, new Vector3(xt, yt, -2f), transform.rotation);
            //wreckClone.GetComponent<TextMesh>().text = "" + univ.num2notaSost(i);
            //wreckClone.GetComponent<TextMesh>().text = "" + univ.getEscalaActual().num2nota12(i);
            wreckClone.GetComponent<TextMesh>().text = "" + univ.num2notaSostBemol(i);

            wreckClone.GetComponent<TextMesh>().fontSize = 120;
            wreckClone.transform.localScale = new Vector3(0.3f, 0.3f, 0.3f);
            wreckClone.transform.parent = transform;
            wreckClone.SetActive(true);
            wreckClone.name = "Circulitos " + univ.num2notaSost(i);
            //wreckClone.name = "Circulitos " + univ.num2notaSostBemol(i);

            GameObject sphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            sphere.name = "" + i;
            sphere.tag = "CirculoCromatico";
            sphere.GetComponent<Renderer>().material = lineasMat;
            sphere.GetComponent<Renderer>().material.color = Color.black;
            sphere.transform.position = new Vector3(x, y, -2f);
            sphere.transform.localScale = new Vector3(3, 3, 3);
            sphere.transform.parent = transform;
            sphere.SetActive(false);
            circulos.Add(sphere);
        }

        // Necesito crear las 24 líneas
        for (int i = 0; i < 12; i++)
        {
            for (int j = 0; j < 12; j++)
            {
                GameObject gam = new GameObject();
                gam.gameObject.transform.parent = circulos[i].transform;
                LineRenderer ln = gam.AddComponent<LineRenderer>();
                ln.material = lineasMat;
                ln.SetColors(Color.grey, Color.grey);
                ln.SetWidth(0.4f, 0.4f);
                ln.SetVertexCount(2);
                Vector3 p1 = new Vector3(circulos[i].transform.position.x, circulos[i].transform.position.y, circulos[i].transform.position.z + 2);
                Vector3 p2 = new Vector3(circulos[j].transform.position.x, circulos[j].transform.position.y, circulos[j].transform.position.z + 2);
                ln.SetPosition(0, p1);
                ln.SetPosition(1, p2);
                gam.gameObject.SetActive(true);
            }
        }
    }

    // Update is called once per frame
    void Update()
    {
        //        notasTeclado = tecladoMidi.GetComponent<MidiInput>().notasLista;
    }

    public Color colorDisStroke(float inter)
    {
        Color col = Color.black;
        // Pinta la linea de acuerdo a la consonancia, disonancia
        //        System.out.println("Inter: " + inter % 1);
        //float num = inter - (float) Math.floor(inter);
        float num = 0;
        //        p.println("Inter: " + inter);
        //        p.println("Num: " + num);
        if (num == 0)
        {
            switch ((int)inter)
            {
                case 0:// Octava azul
                    col = new Color(0F, 0F, 1F);
                    // p.stroke(0, 0, 255);
                    break;
                case 1:// 2da menor rojo
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
                case 2:// 2daMayor rojo
                    col = new Color(1F, 0F, 1F);
                    //p.stroke(223, 0, 255);
                    break;
                case 3:// 3ram verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 4:// 3raM verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 5:// Cuarta azul
                    col = new Color(0F, 0F, 1F);
                    //p.stroke(0, 0, 255);
                    break;
                case 6:// tritono rojo
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
                case 7:// Quinta azul
                    col = new Color(0F, 0F, 1F);
                    //p.stroke(0, 0, 255);
                    break;
                case 8:// 6m verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 9:// 6M verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 10:// 7m
                    col = new Color(1F, 0F, 1F);
                    //p.stroke(223, 0, 255);
                    break;
                case 11:// 7M
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
            }
        }
        return col;
    }


    public void actualizarCirculo()
    {
        armAct = pent.armActual;
        //if (pent.etiquetaActualObj.GetComponent<TextMesh>().text!=)
        //textoCirculo.text = pent.etiquetaActualObj.GetComponent<TextMesh>().text;
        //textoCirculo.text=univ.gradoAcordeRomSecEscAct(armAct) + "\n" + armAct.getStringSencillo();

        textoCirculo.text = univ.gradoAcordeRomSec(armAct, univ.stringToEscala(pent.tonEtqAct)) + "\n" + armAct.getStringSencillo();
        //textoCirculo.text = "";
        // Pintar las notas nuevas.
        // Revisar si cambió el acorde
        if (textoCirculo.text.Equals("x\nC*"))
        {
            textoCirculo.text = "";
        }
        if (armAct.notasArmonia.Length > 0)
        {
            // Corre sobre cada una de las notas
            for (int j = 0; j < circulos.Count; j++)
            {
                // Quita el círculo y sus líneas
                circulos[j].SetActive(false);
                // Corre sobre todas las líneas
                for (int k = 0; k < circulos[j].transform.childCount; k++)
                {
                    // Esconde todas las líneas
                    circulos[j].transform.GetChild(k).gameObject.SetActive(false);
                }
                // Corre sobre las notas que se van a tocar
                for (int i = 0; i < armAct.notasArmonia.Length; i++)
                {
                    // Si pertenece la nota al círculo, acivarla.
                    if (float.Parse(circulos[j].name) == armAct.notasArmonia[i] % 12)
                    {
                        circulos[j].SetActive(true);
                        // El problema es activar las líneas correctas
                        break;
                    }
                    // Que corra por todas las líneas y prenda las que sean adecuadas
                    for (int k = 0; k < circulos[j].transform.childCount; k++)
                    {
                        if (k == armAct.notasArmonia[i] % 12)
                        {
                            //                            dis = MatematicasOper.mod(p.abs(armAct.notasArmonia[i] - armAct.notasArmonia[j]), 12);
                            //colorDisStroke(Mathf.Abs(k-i));// cambia color stroke

                            circulos[j].transform.GetChild(k).gameObject.SetActive(true);

                            LineRenderer ln = circulos[j].transform.GetChild(k).GetComponent<LineRenderer>();
                            //ln.SetWidth(0.5f, 0.5f);
                            //ln.SetVertexCount(indCon.Count * 2);
                            ln.material = lineasMat;
                            ln.SetColors(colorDisStroke(Mathf.Abs(j - armAct.notasArmonia[i] % 12)), colorDisStroke(Mathf.Abs(j - armAct.notasArmonia[i] % 12)));
                            //Debug.Log("Int: " + Mathf.Abs(j - armAct.notasArmonia[i] % 12));
                        }
                    }
                }
            }
        }
    }
}
