﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MapaGrafo_cs : MonoBehaviour
{
    private float px;
    private float py;
    private int diam;
    private int radioAcorde;
    private int radioMay;
    private int radioMen;
    private Vector3 posicionPasada;
    private Vector3 posicionActual;

    List<GameObject> circulos;
    public Camera camaraSegiur;
    public GameObject tonGrafo;
    // Use this for initialization
    List<GameObject> listGrafo;
    Rigidbody aVer;
    Pentagrama pr;
    UniversoTonal univ;
    List<EtiquetaNotas> etqArmL;
    MainDatos mainDatos;
    public Material lineasMat;
    void Start()
    {
        mainDatos = GameObject.Find("DATOS_tonalidad").GetComponent<MainDatos>();
        pr = GameObject.Find("Pentagrama").GetComponent<Pentagrama>();
        univ = mainDatos.univ;
        //organico();
        crearGrafo();
        camaraSegiur.transform.position = new Vector3(listGrafo[0].transform.position.x, listGrafo[0].transform.position.y+2, -73);
    }

    // Update is called once per frame
    void Update()
    {
//        actualizarGrafo();
    }

    void crearGrafo()
    {
        px = transform.position.x;
        py = transform.position.y;

        // Crear circulos
        float x, y;
        float ang = -2 * Mathf.PI / 12;
        listGrafo = new List<GameObject>();
        circulos = new List<GameObject>();
        radioAcorde = 30;

        for (int i = 0; i < 84; i = i + 7)
        {
            // Tonalidades mayores
            x = radioAcorde * Mathf.Cos(i / 7 * ang + Mathf.PI / 2);
            y = radioAcorde * Mathf.Sin(i / 7 * ang + Mathf.PI / 2);

            int tonNum = (i) % 12;
            GameObject gam = (GameObject)Instantiate(tonGrafo, transform.position, transform.rotation);
            gam.GetComponent<TonalidadGrafo_cs>().tonStr = "" + univ.num2notaSost(tonNum) + "M";
            gam.name =   univ.num2notaSost(tonNum) + "M";
            gam.transform.parent = transform;
            //SpringJoint spr = gam.AddComponent<SpringJoint>();
            gam.transform.position += new Vector3(x, y - 1f);
            listGrafo.Add(gam);
        }

        radioAcorde = 20;

        for (int i = 0; i < 84; i = i + 7)
        {
            // Tonalidades menores
            x = radioAcorde * Mathf.Cos(i / 7 * ang + Mathf.PI / 2);
            y = radioAcorde * Mathf.Sin(i / 7 * ang + Mathf.PI / 2);
            int tonNum = (i + 9) % 12;
            GameObject gam = (GameObject)Instantiate(tonGrafo, transform.position, transform.rotation);
            gam.GetComponent<TonalidadGrafo_cs>().tonStr = "" + univ.num2notaSost(tonNum) + "m";
            gam.transform.parent = transform;
            gam.name = (univ.num2notaSost(tonNum)) + "m";
            gam.transform.position += new Vector3(x, y - 1f);
            listGrafo.Add(gam);

        }
        // correr sobre todas las combinaciones
        // Debo guardar una lista de los elementos con los que se conecta, y luego conectarlo
        List<int> indCon = new List<int>();
        for (int i = 0; i < listGrafo.Count; i++)
        {
            indCon = new List<int>();
            // Sobre un mismo objeto.. revisar con cuantos se conecta
            for (int j = 0; j < listGrafo.Count; j++)
            {
                if (i != j && univ.stringToEscala(listGrafo[i].name).distancia(univ.stringToEscala(listGrafo[j].name)) <= 1)
                {
                    indCon.Add(j);
                }
            }
            // Aqui hacer los line renderers.
            LineRenderer ln = listGrafo[i].GetComponent<LineRenderer>();
            ln.SetWidth(0.5f, 0.5f);
            ln.SetVertexCount(indCon.Count * 2);
            ln.material = lineasMat;
//            Debug.Log("Cuantos materiales: " + ln.materials.Length);
            ln.SetColors(Color.blue, Color.blue);
            for (int k = 0; k < indCon.Count; k++)
            {
                ln.SetPosition(2*k, listGrafo[i].transform.position);
                ln.SetPosition(2*k + 1, listGrafo[indCon[k]].transform.position);
            }
        }
    }

    //void organico()
    //{
    //    // Aqui se crean las tonalidades de la forma organica
    //    listGrafo = new List<GameObject>();
    //    for (int i = 0; i < 12; i++)
    //    {
    //        GameObject gam = (GameObject)Instantiate(tonGrafo, transform.position, transform.rotation);
    //        gam.GetComponent<TonalidadGrafo_cs>().tonStr = "" + univ.num2notaSost(i) + "M";
    //        gam.name = "Tonalidad: " + i + "M";
    //        gam.transform.parent = transform;
    //        //SpringJoint spr = gam.AddComponent<SpringJoint>();

    //        gam.transform.position += new Vector3(Random.Range(-150, 150), Random.Range(-150, 150), -1);
    //        listGrafo.Add(gam);
    //    }
    //    for (int i = 0; i < 12; i++)
    //    {
    //        GameObject gam = (GameObject)Instantiate(tonGrafo, transform.position, transform.rotation);
    //        gam.GetComponent<TonalidadGrafo_cs>().tonStr = "" + univ.num2notaSost(i) + "m";
    //        gam.transform.parent = transform;
    //        gam.name = "Tonalidad: " + i + "m";
    //        //gam.AddComponent<SpringJoint>();
    //        gam.transform.position += new Vector3(Random.Range(-150, 150), Random.Range(-150, 150), -1);
    //        listGrafo.Add(gam);
    //    }

    //    for (int i = 0; i < listGrafo.Count; i++)
    //    {
    //        //            DistanceJoint2D spr = listGrafo[i].AddComponent<DistanceJoint2D>();
    //        //spr.connectedBody = Random.Range(1, 15);
    //        //            listGrafo[i].GetComponent<Rigidbody>().useGravity = false;
    //        LineRenderer ln = listGrafo[i].GetComponent<LineRenderer>();
    //        ln.SetWidth(0.3f, 0.3f);
    //        ln.SetVertexCount(2);
    //        ln.SetPosition(0, listGrafo[i].transform.position);
    //        ln.SetPosition(1, listGrafo[(i + 7) % listGrafo.Count].transform.position);

    //        listGrafo[i].GetComponent<DistanceJoint2D>().connectedBody = listGrafo[(i + 7) % listGrafo.Count].GetComponent<Rigidbody2D>();
    //        listGrafo[i].GetComponent<DistanceJoint2D>().distance = 10;

    //        //          aVer = listGrafo[(i + 1) % listGrafo.Count].GetComponent<Rigidbody>();
    //        //listGrafo[i].GetComponent<SpringJoint>().set connectedBody = (Rigidbody)aVer;
    //        //            spr.connectedBody = listGrafo[(i + 1) % listGrafo.Count].GetComponent<Rigidbody>();

    //    }
    //}

    public void actualizarGrafo()
    {
        Vector3 v1,v2;
        etqArmL = new List<EtiquetaNotas>();

        for (int i = 0; i < mainDatos.objEtiquetas.Count; i++)
        {
            etqArmL.Add(mainDatos.objEtiquetas[i].GetComponent<EtiquetaNotas>());
        }

        for (int i = 0; i < listGrafo.Count; i++)
        {
            for (int j = 0; j < etqArmL.Count; j++)
            {
                listGrafo[i].GetComponent<TonalidadGrafo_cs>().activoInt = 0;
                // Aqui pinta la tonalidad activa
                if (pr.tonEtqAct == listGrafo[i].GetComponent<TonalidadGrafo_cs>().tonStr)
                {
                    listGrafo[i].GetComponent<TonalidadGrafo_cs>().activoInt = 2;
                    v1 = camaraSegiur.transform.position;
                    v2 = new Vector3(listGrafo[i].transform.position.x, listGrafo[i].transform.position.y+2, -73);
                    posicionPasada = v1;
                    posicionActual = v2;
                    //camaraSegiur.transform.position = Vector3.Lerp(v1, v2, Time.deltaTime * 1);
                   //   float num = camaraSegiur.orthographicSize;
                   // camaraSegiur.orthographicSize = Vector3.Lerp(new Vector3(num, 0, 0), new Vector3(num+ 15, 0, 0), Time.deltaTime * 1).x;
                    break;
                }
                if (etqArmL[j].tonalidadEtiqueta == listGrafo[i].GetComponent<TonalidadGrafo_cs>().tonStr)
                {
                    listGrafo[i].GetComponent<TonalidadGrafo_cs>().activoInt = 1;
                    //camaraSegiur.transform.position = new Vector3(listGrafo[i].transform.position.x, listGrafo[i].transform.position.y,-73);
                    break;
                }
                // Si es unda de las tonalidades pasadas
            }
        }
    }

    public void segurTonalidadEtiqueta()
    {
        camaraSegiur.transform.position = Vector3.Lerp(posicionPasada, posicionActual, Time.deltaTime * 1);
    }
}
