﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MobiusCrear : MonoBehaviour {

    public GameObject objPentagrama;
    public Material materialEsfera;
    Armonia a;
    Color colLineas;
	// Use this for initialization
	void Start () {
	// Correr sobre todos los elementos y ponerles una esferita que se vea de atras.. como el tonnetz
        foreach (Transform g in transform)
        {
            GameObject sphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            sphere.name = "" + g.name;
            sphere.tag = "EsferaMoebius";
            sphere.GetComponent<Renderer>().material = materialEsfera;
            sphere.GetComponent<Renderer>().material.color = Color.red;
            sphere.transform.parent = g.transform;
            //                sphere.transform.position = g2.transform.position;
            sphere.transform.position = new Vector3(g.transform.position.x, g.transform.position.y, g.transform.position.z + 20);
            sphere.transform.localScale = new Vector3(20, 20, 1.7f);
            sphere.SetActive(true);
            //circulos.Add(sphere);
        }
        actualizarMobius();
	}
	
	// Update is called once per frame
	void Update () {
	
	}

    public void actualizarMobius()
    {
        //// Obtener los intervalos del acorde
        //Armonia a = new Armonia(new float[3] { 8f, 12f, 15f });
        a = objPentagrama.GetComponent<Pentagrama>().armActual;
        List<float[]> inervalos = a.calcularIntervalos();
        foreach (Transform g in transform)
        {
            g.transform.GetChild(0).GetComponent<Renderer>().material.color = Color.white;
            foreach (float[] intAc in inervalos)
            {
                string nombre = g.name;
                string[] numeros = nombre.Split('-');
                float n1 = float.Parse(numeros[0]);
                float n2 = float.Parse(numeros[1]);
                //Debug.Log("Numeros mobius: " + n1 + " " + n2);
                if (n1 == intAc[0] && n2 == intAc[1])
                {
                    colLineas = colorDisStroke(Mathf.Abs(n1 - n2));
                    g.transform.GetChild(0).GetComponent<Renderer>().material.color = colLineas;
                }
            }
        }
        // Correr sobre todos los objetos mobius
        // correr sobre todos los intervalos
            // si los intervalos de objetos y de acorde son iguales,pintar de un color.
    }

    public Color colorDisStroke(float inter)
    {
        Color col = Color.black;
        // Pinta la linea de acuerdo a la consonancia, disonancia
        //        System.out.println("Inter: " + inter % 1);
        //float num = inter - (float) Math.floor(inter);
        float num = 0;
        //        p.println("Inter: " + inter);
        //        p.println("Num: " + num);
        if (num == 0)
        {
            switch ((int)inter)
            {
                case 0:// Octava azul
                    col = new Color(0F, 0F, 1F);
                    // p.stroke(0, 0, 255);
                    break;
                case 1:// 2da menor rojo
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
                case 2:// 2daMayor rojo
                    col = new Color(1F, 0F, 1F);
                    //p.stroke(223, 0, 255);
                    break;
                case 3:// 3ram verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 4:// 3raM verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 5:// Cuarta azul
                    col = new Color(0F, 0F, 1F);
                    //p.stroke(0, 0, 255);
                    break;
                case 6:// tritono rojo
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
                case 7:// Quinta azul
                    col = new Color(0F, 0F, 1F);
                    //p.stroke(0, 0, 255);
                    break;
                case 8:// 6m verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 9:// 6M verde
                    col = new Color(0F, 1F, 0F);
                    //p.stroke(0, 255, 0);
                    break;
                case 10:// 7m
                    col = new Color(1F, 0F, 1F);
                    //p.stroke(223, 0, 255);
                    break;
                case 11:// 7M
                    col = new Color(1F, 0F, 0F);
                    //p.stroke(255, 0, 0);
                    break;
            }
        }
        return col;
    }

}
