﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class TonalidadGrafo_cs : MonoBehaviour
{
    public GameObject objEtqGraf;
    public string tonStr;
    public Sprite spriteTonActual;
    public Sprite spriteTonPasadas;
    public Sprite spriteTonLibre;
    public int activoInt = 0; // 0 libre, 1 pasado, 2 activo
    List<EtiquetaNotas> compL;
    //ListBoton btsL = new ListBoton();
    //ListEntero xL = new ListEntero();
    //ListEntero yL = new ListEntero();

    List<EtiquetaNotas> etqArmL;
    List<string> centrosStrL;
    List<int> indices;
    Pentagrama pr;
    UniversoTonal univ;
    List<Vector3> posL;
    List<GameObject> objEtqGrafList;
    EtiquetaNotas etq;
    MainDatos mainDatos;
    float cuantos, porcentaje;
    // Use this for initialization
    void Start()
    {
        mainDatos = GameObject.Find("DATOS_tonalidad").GetComponent<MainDatos>();
        pr = GameObject.Find("Pentagrama").GetComponent<Pentagrama>();
        //Debug.Log("Pentagrama ´" + pr);
        univ = mainDatos.univ;
        objEtqGrafList = new List<GameObject>();

        transform.GetChild(1).GetComponent<TextMesh>().text = tonStr;
    }

    // Update is called once per frame
    void Update()
    {
        // Revisar si está activo
    
        etqArmL = new List<EtiquetaNotas>();
        for (int i = 0; i < mainDatos.objEtiquetas.Count; i++)
        {
            etqArmL.Add(mainDatos.objEtiquetas[i].GetComponent<EtiquetaNotas>());
        }

        // Revisar cuantos acordes distintos hay
        compL = new List<EtiquetaNotas>();
        indices = new List<int>();
        bool pertenece = false;

        for (int i = 0; i < etqArmL.Count; i++)
        {
            for (int j = 0; j < compL.Count; j++)
            {
                // Si no está en compL
                // agregarlo a la lista
                // y guardar indice j
                pertenece = false;
                //if (compL[j].armonia.equivalente(etqArmL[i].armonia))
                if (compL[j].armonia.equivalente(etqArmL[i].armonia))
                {
                    indices.Add(j);
                    pertenece = true;
                    break;
                }
                // Si sí estaba en compL
                // guardar su índice j
            }
            if (pertenece == false)
            {
                // Lista de acordes distintos y sus índices
                compL.Add(etqArmL[i]);
                indices.Add(compL.Count - 1);
            }
        }

        // Aqui debo agregar y quitar los acordes que se usan en esta tonalidad
        posL = new List<Vector3>();
        float xL, yL;
        string str = "";

        for (int i = 0; i < objEtqGrafList.Count; i++)
        {
            // Aqui se me está llendo mucho poder de compu
            Destroy(objEtqGrafList[i]);
        }

        // Aqui se acomodan en el círculo adecuado.
        float contX = 0f;
        objEtqGrafList = new List<GameObject>();
        cuantos = 0;
        for (int i = 0; i < compL.Count; i++)
        {
            etq = compL[i];
            // Mejor revisar si es un grado de alguna tonalidad
            if (univ.gradoSencillo(etq.armonia, univ.stringToEscala(this.tonStr)) > 0)
            //if (etq.tonalidadEtiqueta == this.tonStr)
            {
                cuantos++;
                xL = transform.position.x + 2f * (contX % 3) - 2f;
                yL = transform.position.y - ((int)contX / (int)3) + 1;

                posL.Add(new Vector3(xL, yL, -50f));
                // Instantiate
                GameObject wreckClone = (GameObject)Instantiate(objEtqGraf, posL[posL.Count - 1], transform.rotation);
                str = univ.gradoAcordeRomSec(etq.armonia, univ.stringToEscala(this.tonStr));
                wreckClone.name = "SubCirculo " + str;
                // str += univ.gradoAcordeRomSec(etq.armonia, univ.stringToEscala(etq.tonalidadEtiqueta)) + "\n" + etq.armonia.getStringSencillo();
                if (str.Equals("x"))
                {
                    str = etq.armonia.getStringSencillo();
                }
                wreckClone.GetComponent<TextMesh>().text = str;
                objEtqGrafList.Add(wreckClone);
                contX++;
            }
        }
        porcentaje = cuantos / compL.Count;
        porcentajeColor();
        //Debug.Log("Porcentaje " + porcentaje);
    }

    public void switchActivo()
    {
        switch (activoInt)
        {
            case 0:
                transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = spriteTonLibre;
                break;
            case 1:
                transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = spriteTonPasadas;
                break;
            case 2:
                transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = spriteTonActual;
                break;
        }
    }

    public void porcentajeColor()
    {
        if (porcentaje > 0.5f)
        {
            transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = spriteTonActual;
        }
        else
        {
            transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = spriteTonPasadas;
        }
    }

}
