﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;

public class ListaTonalidades_cs : MonoBehaviour
{

    // Externos
    public GameObject objDatosTonalidad;
    public GameObject objPentagrama;
    public GameObject objCambioTonalidad;

    public bool activado = false;
    MIDI_datos midi;
    UniversoTonal univ;
    MainDatos mainDatos;
    // Condiciones
    bool mousePressIzq = false;
    public List<GameObject> listTonalidades;
    Pentagrama pent;
    Ray ray;
    RaycastHit hit;

    void Start()
    {
        // GET externos
        mainDatos = objDatosTonalidad.GetComponent<MainDatos>();
        univ = mainDatos.univ;
        midi = objDatosTonalidad.GetComponent<MIDI_datos>();
        listTonalidades = new List<GameObject>();
        pent = objPentagrama.GetComponent<Pentagrama>();
    }

    // Update is called once per frame
    void Update()
    {
        // Aqui debo crear la lista de tonalidades
        if (mainDatos.isFuncionandoArchivo)
        {
            mouseEscuchar();
        }

    }

    void mouseEscuchar()
    {
        // Al presionar la tonalidad actual
        // Si se presionó izquierdo
        //Debug.Log("Escuchar mouse");

        if (Input.GetMouseButtonDown(0))
        {
            //Debug.Log("Presionado cambio de tonalidad");
            mousePressIzq = true;
            if (mainDatos.isTonalidad)// Si se tiene preparada una tonalidad
            {
                Vector3 vecMousCam = Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, 9f));
                // Aqui reccorrer las tonalidades
                GameObject wreckClone = (GameObject)Instantiate(objCambioTonalidad, new Vector3(vecMousCam.x, 5.32f, vecMousCam.z), transform.rotation);
                wreckClone.tag = "ListaTonalidades";
                wreckClone.GetComponent<TextMesh>().name = mainDatos.tonalidadStr;
                wreckClone.GetComponent<TextMesh>().fontSize = 350;

                wreckClone.GetComponent<TextMesh>().text = "\n\n\n\n\n\n\nTonalidad:" + mainDatos.tonalidadStr;

                wreckClone.GetComponent<TextMesh>().color = Color.black;
                mainDatos.isTonalidad = false;
                listTonalidades.Add(wreckClone);
                //pent.moverCuadritosTonalidad(wreckClone,+1);
                //pent.recalcularModificadorNotaMIDI();
            }
            pent.actualizarRevizarTodo();
        }
        else if (Input.GetMouseButtonUp(0))
        {
            mousePressIzq = false;
            // Aqui crear el botoncito de la tonalidad
        }

        // Si se presionó derecho
        if (Input.GetMouseButtonDown(1))
        {
            ray = Camera.main.ScreenPointToRay(Input.mousePosition);

            if (Physics.Raycast(ray, out hit))
            {
                // Si chocó con etiquetas BORRAR.. debo cuidar que se borre bien la lista
                if (hit.collider.tag == "ListaTonalidades")
                {
//                    pent.moverCuadritosTonalidad(hit.transform.gameObject,-1);
                    // Restar 15 a cada tonalidad antes de quitarla
                    //for (int m = 0; m < listTonalidades.Count; m++)
                    //{
                    //    if (hit.transform.gameObject.transform.position.x < listTonalidades[m].transform.position.x)
                    //    {
                    //        Debug.Log("Restar tonalidad");
                    //        listTonalidades[m].transform.position += new Vector3(-15*pent.cuantoestirado, 0, 0);
                    //    }
                    //}
                    listTonalidades.Remove(hit.transform.gameObject);
                    Destroy(hit.transform.gameObject);
                    //pent.recalcularModificadorNotaMIDI();
                }
            }
            pent.actualizarRevizarTodo();
        }

        // MOVIMIENTO SIN CLICK
        // Revisar Raycast solo con movimiento
        //ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        //if (Physics.Raycast(ray, out hit))
        //{
        //    // Si chocó con etiquetas
        //    if (hit.collider.tag == "")
        //    {
        //    }
        //}

        // MOVIMIENTO CON CLICK (drag)
        //if (mousePressIzq)
        //{
        //    // Revisar Raycast solo con con movimiento y click izq
        //    ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        //    if (Physics.Raycast(ray, out hit))
        //    {
        //        if (hit.collider.tag == "")
        //        {
        //            //Debug.Log("Choque con: " + hit.collider.name);
        //        }
        //    }
        //}
    }
}
