﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;
using System.IO;
using System.Xml;
using System.Linq;
using System;


public class Pentagrama : MonoBehaviour
{
    // Externos
    public GameObject mainCamara;
    public GameObject objDatosTonalidad;
    public GameObject objCargarMidi;
    public GameObject objXML;
    public GameObject objListaTon;
    public GameObject objNota;
    public GameObject objEtiquetaNotas;
    public GameObject objBtnPlay;
    public GameObject objSliderPlay;
    public GameObject objCirculoCrom;
    public GameObject objTonnetz;
    public GameObject objGrafoTonal;
    public GameObject objMoebius;
    public GameObject objCompas;
    GameObject objPlayer;
    public EtiquetaNotas etiquetaActualObj;
    //public GameObject tecladoMidi;
    public Material materialPentagrama;
    public GameObject objBarraCompas;
    MIDI_datos midi;
    UniversoTonal univ;
    bool crear = true;
    public float cuantoestirado = 1;
    ListaTonalidades_cs listTonalidadesObj;
    // Registro de notas
    public List<float> notas;
    public List<float> cuadritosId;
    public List<float> indicesActuales;
    public List<GameObject> cuadritosNotaList;
    public List<GameObject> cuadritosNotaTeclado;
    public List<GameObject> barrasCompasLista;

    List<float> notasTeclado;
    List<float> notasTecladoPasadas;

    public int cuantosAtras = 0;
    public Armonia armActual;
    public string tonEtqAct;
    List<float> listaTodosIndices;
    List<GameObject> objEtiquetas;
    public float minNotas = 0;
    public float maxNotas = 10000;
    // Condiciones
    bool mousePressIzq = false;
    float minimoX = 100000;
    float maximoX = -100000;
    float minimoY = 100000;
    float maximoY = -100000;

    // Sistema
    //    TextMesh textoCirculo;
    Ray ray;
    RaycastHit hit;
    //public Font guiFont;
    //public Material guiFontMaterial;
    MainDatos mainDatos;

    public List<NotaXML> notasXMList;
    public List<Compas> compasXMList;
    public List<object> listaObjXML;

    void Awake()
    {
        tonEtqAct = "CM";
        objPlayer = transform.GetChild(0).gameObject;
        // Inicializar listas y propiedades
        cuadritosNotaList = new List<GameObject>();
        cuadritosNotaTeclado = new List<GameObject>();
        barrasCompasLista = new List<GameObject>();
        notasTecladoPasadas = new List<float>();
        armActual = new Armonia(new float[1] { 0 });
        Debug.Log("Acabo de crear la armonía " + armActual.getStringSencillo());
        objEtiquetas = new List<GameObject>();

        // GET externos
        mainDatos = objDatosTonalidad.GetComponent<MainDatos>();
        univ = mainDatos.univ;
        // Aqui debo poner, CARGAR NOTAS
        midi = objCargarMidi.GetComponent<MIDI_datos>();
        listTonalidadesObj = objListaTon.GetComponent<ListaTonalidades_cs>();
        
        // Inicializar los objetos pentagrama
        //        textoCirculo.text = "Cm";
        crearLineasPentagrama();
    }

    // Update is called once per frame
    void Update()
    {
        //        notasTeclado = tecladoMidi.GetComponent<MidiInput>().notasLista;
        mouseEscuchar();
        //        crearAcordeTeclado();
        actualizarRevizarTodo();
    }

    void mouseEscuchar()
    {
        if (!objPlayer.GetComponent<PlayBar>().play)
        {
            // Si se presionó izquierdo
            if (Input.GetMouseButtonDown(0))
            {
                comienzaSeleccionAcorde();
            }
            else if (Input.GetMouseButtonUp(0))
            {
                // Termina selección de acorde
                mousePressIzq = false;
                terminaSelecciondeAcordes();
            }

            // Si se presionó derecho
            if (Input.GetMouseButtonDown(1))
            {
                borrarEtiquetaNotas();
            }

            // MOVIMIENTO SIN CLICK
            // Revisar Raycast solo con movimiento
            revisarEtiquetaActualMovimiento();

            // MOVIMIENTO CON CLICK
            if (mousePressIzq)
            {
                revisarMouseAgregarNota();
            }
        }
    }

   private void comienzaSeleccionAcorde()
    {
        // Comienza selección de acorde
        mousePressIzq = true;
        notas = new List<float>();
        cuadritosId = new List<float>();
        indicesActuales = new List<float>();
        minimoX = 100000;
        maximoX = -100000;
        actualizarRevizarTodo();
    }

   private void terminaSelecciondeAcordes()
    {
        if (notas.Count > 0)
        {
            Armonia arm = new Armonia(notas);
            //textoCirculo.text = arm.getStringSencillo();
            // Aqui crear la etiqueta del acorde
            armActual = arm;
            agregarAcorde(arm);
            //                    tonEtqAct = mainDatos.tonalidadStr;
        }
        actualizarRevizarTodo();
    }

   private void borrarEtiquetaNotas()
    {
        ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        if (Physics.Raycast(ray, out hit))
        {
            // Si chocó con etiquetas BORRAR.. debo cuidar que se borre bien la lista
            if (hit.collider.tag == "EtiquetaNotas")
            {
                //Buscar el indice de lal ista
                hit.collider.GetComponent<EtiquetaNotas>().cuadritosId = new List<float>();
                objEtiquetas.Remove(hit.transform.gameObject);
                Destroy(hit.transform.gameObject);
                // imprimirListaEtiquetas();
                cuadritosId = new List<float>();
                armActual = new Armonia();
                // Debug.Log("BORRAR: Cuantas etiquetas " + objEtiquetas.Count);
            }
        }
        actualizarRevizarTodo();
    }

   private void revisarEtiquetaActualMovimiento()
    {
        ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        if (Physics.Raycast(ray, out hit))
        {
            // Si chocó con etiquetas seleccionar que es la actual
            if (hit.collider.tag == "EtiquetaNotas")
            {
                EtiquetaNotas etiqueta = hit.collider.GetComponent<EtiquetaNotas>();
                armActual = etiqueta.armonia;
                //univ.setEscalaAct() 
                tonEtqAct = etiqueta.tonalidadEtiqueta;
                cuadritosId = etiqueta.cuadritosId;
                actualizarRevizarTodo();
                etiquetaActualObj = etiqueta;
                objGrafoTonal.GetComponent<MapaGrafo_cs>().segurTonalidadEtiqueta();
            }
        }
    }

   private void revisarMouseAgregarNota()
    {
        // Revisar Raycast solo con con movimiento y click izq
        ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        if (Physics.Raycast(ray, out hit))
        {
            if (hit.collider.tag == "NotaRedonda")
            {
                //Debug.Log("Choque con: " + hit.transform.name);
                // Necesito tomar registro de la coordenada x más baja
                if (hit.transform.position.x < minimoX)
                {
                    minimoX = hit.transform.position.x;
                }
                if (hit.transform.position.x > maximoX)
                {
                    maximoX = hit.transform.position.x;
                }
                if (hit.transform.position.y < minimoY)
                {
                    minimoY = hit.transform.position.y;
                }
                if (hit.transform.position.y > maximoY)
                {
                    maximoY = hit.transform.position.y;
                }
                NotaRedonda cuad = hit.collider.GetComponent("NotaRedonda") as NotaRedonda;
                agregarNota(float.Parse(hit.collider.name), cuad.id);
            }
        }
        actualizarRevizarTodo();
    }

    private void agregarNota(float not, float indice)
    {
        bool agregar = true;
        // revisar si en notas no está la nota ya
        for (int i = 0; i < indicesActuales.Count; i++)
        {
            if (indice == indicesActuales[i])
            {
                agregar = false;
                break;
            }
        }
        if (agregar)
        {
            notas.Add(not);
            indicesActuales.Add(indice);
            armActual = new Armonia(notas);
            cuadritosId.Add(indice);
            hit.collider.GetComponent<Renderer>().material.color = Color.blue;
        }
    }

    public void actualizarRevizarTodo()
    {
        asignarColores();
        objCirculoCrom.GetComponent<CrearCirculo>().actualizarCirculo();
        revisarTonalidadesMIDI();
        if (objTonnetz.active)
        {
            objTonnetz.GetComponent<Tonnetz_cs>().actualizarTonetz();
        }
        if (objGrafoTonal.active)
        {
            objGrafoTonal.GetComponent<MapaGrafo_cs>().actualizarGrafo();
        }
        if (objMoebius.active)
        {
            objMoebius.GetComponent<MobiusCrear>().actualizarMobius();
        }
    }

    private void revisarTonalidadesMIDI()
    {
        // Se revisa de acuerdo a todas las tonalidades, cual es la de este acorde, de acuerdo a la posición
        listTonalidadesObj = objListaTon.GetComponent<ListaTonalidades_cs>();
        for (int i = 0; i < listTonalidadesObj.listTonalidades.Count; i++)
        {
            for (int j = 0; j < objEtiquetas.Count; j++)
            {
                // Revisar si la tonalidad está antes o después de las tonalidades string
                if (objEtiquetas[j].transform.position.x > listTonalidadesObj.listTonalidades[i].transform.position.x)
                {
                    objEtiquetas[j].GetComponent<EtiquetaNotas>().tonalidadEtiqueta = listTonalidadesObj.listTonalidades[i].name;
                }
            }
        }
    }

    private void agregarAcorde(Armonia arm)
    {
        GameObject textGo = (GameObject)Instantiate(objEtiquetaNotas, new Vector3(minimoX, 16, -3f), transform.rotation);
        EtiquetaNotas etqNotas = textGo.GetComponent<EtiquetaNotas>();
        etqNotas.armonia = arm;
        etqNotas.cuadritosId = cuadritosId;
        // Agregar objeto a la lista
        objEtiquetas.Add(textGo);
        mainDatos.objEtiquetas = objEtiquetas;
        minimoX = 100000;
        maximoX = -100000;
        minimoY = 100000;
        maximoY = -100000;
    }

    //void crearAcordeTeclado()
    //{
    //    string indice;

    //    if (notasTeclado != null && notasTecladoPasadas != null)
    //    {
    //        string c = "";
    //        foreach (float n in notasTeclado)
    //        {
    //            c += "," + n;
    //        }
    //        // Debug.Log(c);
    //        c = "";
    //        foreach (float n in notasTecladoPasadas)
    //        {
    //            c += "," + n;
    //        }
    //        // Debug.Log(c);

    //        if (!Enumerable.SequenceEqual(notasTeclado, notasTecladoPasadas))
    //        {
    //            foreach (GameObject g in cuadritosNotaTeclado)
    //            {
    //                Destroy(g);
    //            }
    //            foreach (float n in notasTeclado)
    //            {
    //                indice = univ.stringToEscala(mainDatos.tonalidadStr).indiceTabla(n);
    //                float notaCorregida = float.Parse(indice.Split(',')[0]);
    //                string simboloPoner = indice.Split(',')[1];
    //                GameObject wreckClone = (GameObject)Instantiate(objNota, new Vector3(-10 + 0 / 35, -38 + notaCorregida, -1f), transform.rotation);
    //                wreckClone.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
    //                wreckClone.name = "MIDI " + n;
    //                wreckClone.tag = "NotaRedonda";
    //                wreckClone.transform.parent = transform;
    //                NotaRedonda cuadNota = wreckClone.GetComponent<NotaRedonda>();
    //                cuadNota.id = (int)n;
    //                cuadNota.nota = n;
    //                // Aqui va la información de sostenidos y todo eso
    //                cuadNota.tonalidadString = mainDatos.tonalidadStr;
    //                cuadNota.indicePent = notaCorregida; // Esto se tiene que calcular en Tonalidad de acuerdo a el número midi
    //                Debug.Log("Pentagrama: " + cuadNota.indicePent);
    //                // Poner el simbolo
    //                cuadNota.simbolo = simboloPoner;

    //                Vector3 pos = wreckClone.transform.GetChild(0).gameObject.transform.position;
    //                wreckClone.transform.GetChild(0).gameObject.transform.position = new Vector3(pos.x, pos.y, pos.z - 5.5f);

    //                wreckClone.transform.GetChild(0).gameObject.SetActive(false);
    //                cuadritosNotaTeclado.Add(wreckClone);
    //            }
    //        }
    //    }
    //    //        List<GameObject> temporary = new List<GameObject>(master);
    //    notasTecladoPasadas = new List<float>(notasTeclado);
    //}

    public void cambiarEspaciamiento(float cuanto)
    {
        objBtnPlay.GetComponent<ClickBotonPlay>().setStop();
        // DE TODO!!
        objPlayer.GetComponent<PlayBar>().play = false;
        cuantoestirado *= cuanto;
        foreach (GameObject g in cuadritosNotaList)
        {
            g.transform.position = new Vector3(cuanto * g.transform.position.x, g.transform.position.y, g.transform.position.z);
        }
        foreach (GameObject g in objListaTon.GetComponent<ListaTonalidades_cs>().listTonalidades)
        {
            g.transform.position = new Vector3(cuanto * g.transform.position.x, g.transform.position.y, g.transform.position.z);
        }
        foreach (GameObject g in objEtiquetas)
        {
            g.transform.position = new Vector3(cuanto * g.transform.position.x, g.transform.position.y, g.transform.position.z);
        }
        foreach (GameObject g in barrasCompasLista)
        {
            g.transform.position = new Vector3(cuanto * g.transform.position.x, g.transform.position.y, g.transform.position.z);
        }

        minNotas = cuadritosNotaList[0].transform.position.x;
        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        //Debug.Log("Min " + minNotas);
        //Debug.Log("Man " + maxNotas);
        objSliderPlay.GetComponent<SliderPlay>().cambiarEscala(minNotas, maxNotas);
    }

    public void crearCuadritosNotasMIDI()
    {
        listTonalidadesObj.activado = true;
        float n;
        string indice = "";
        for (int i = 0; i < mainDatos.eventosL.Count; i++)
        {
            if (mainDatos.eventosL[i].getOnOff() == 'o' && mainDatos.eventosL[i].getVeloc() > 0)
            {
                n = (float)mainDatos.eventosL[i].getNota();
                indice = univ.stringToEscala(mainDatos.tonalidadStr).indiceTabla(n);
                float notaCorregida = float.Parse(indice.Split(',')[0]);
                string simboloPoner = indice.Split(',')[1];
                //Debug.Log("ind: "+indice);
                //Debug.Log("Pos x: " + (float)mainDatos.eventosL[i].getTiempo() / 35);
                GameObject wreckClone = (GameObject)Instantiate(objNota, new Vector3(10 + (float)mainDatos.eventosL[i].getTiempo() / 35, -38 + notaCorregida, -1f), transform.rotation);
                wreckClone.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
                wreckClone.name = "" + mainDatos.eventosL[i].getNota();
                wreckClone.tag = "NotaRedonda";
                wreckClone.transform.parent = transform;
                wreckClone.GetComponent<Renderer>().material = materialPentagrama;
                NotaRedonda cuadNota = wreckClone.GetComponent<NotaRedonda>();
                cuadNota.id = i;
                cuadNota.nota = notaCorregida;
                // Aqui va la información de sostenidos y todo eso
                cuadNota.tonalidadString = "Cm";
                cuadNota.indicePent = notaCorregida; // Esto se tiene que calcular en Tonalidad de acuerdo a el número midi
                // Poner el simbolo
                cuadNota.simbolo = simboloPoner;

                // Los circulitos de seleccionado
                Vector3 pos = wreckClone.transform.GetChild(0).gameObject.transform.position;
                wreckClone.transform.GetChild(0).gameObject.transform.position = new Vector3(pos.x, pos.y, pos.z - 5.5f);

                wreckClone.transform.GetChild(0).gameObject.SetActive(false);
                wreckClone.gameObject.SetActive(true);
                cuadritosNotaList.Add(wreckClone);
            }
        }
        //        revisarDistancias();
        minNotas = cuadritosNotaList[0].transform.position.x;
        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        //Debug.Log("Min " + minNotas);
        //Debug.Log("Man " + maxNotas);
        objSliderPlay.GetComponent<SliderPlay>().cambiarEscala(minNotas, maxNotas);
    }

    public void crearCuadritosNotasXML()
    {
        listTonalidadesObj.activado = true;
        float n;
        string indice = "";
        notasXMList = objXML.GetComponent<XML_cargar>().notasXMList;
        compasXMList = objXML.GetComponent<XML_cargar>().listaCompases;
        //listaObjXML = objXML.GetComponent<XML_cargar>().listaObjXML;
        int compasesCuantos = 0;
        //int notasCuantas = 0;
        //float recorrerCompases = 0;
        //for (int i = 0; i < listaObjXML.Count; i++)
        //{
        //    if ((listaObjXML[i].GetType()).Equals(typeof(Compas)))
        //    {
        //        Compas comp = (Compas)listaObjXML[i];
        //        GameObject objArmadura = (GameObject)Instantiate(objCompas, new Vector3(10 + comp.pxInic * 4 - 3, -1.91f, -1f), transform.rotation);
        //        // objArmadura.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
        //        objArmadura.name = "Compas " + compasesCuantos;
        //        objArmadura.GetComponent<CompasObjeto>().keyNum = comp.keyNum;
        //        objArmadura.GetComponent<CompasObjeto>().beats = comp.beats;
        //        objArmadura.GetComponent<CompasObjeto>().beatType = comp.beatType;
        //        objArmadura.transform.parent = transform;
        //        recorrerCompases += objArmadura.GetComponent<CompasObjeto>().anchoTontal*4f;
        //        Debug.Log("Pentagrama Ancho total compases " + objArmadura.GetComponent<CompasObjeto>().anchoTontal);
        //        compasesCuantos++;
        //    }
        //    if ((listaObjXML[i].GetType()).Equals(typeof(NotaXML)))
        //    {
        //        // Debo corregir la altura XML
        //        NotaXML notaXML = (NotaXML)listaObjXML[i];
        //        n = notaXML.numMidi;
        //        indice = univ.stringToEscala(mainDatos.tonalidadStr).indiceTabla(n);
        //        float notaCorregida = float.Parse(indice.Split(',')[0]);
        //        string simboloPoner = indice.Split(',')[1];
        //        //Debug.Log("ind: "+indice);
        //        GameObject objetoNota = (GameObject)Instantiate(objNota, new Vector3(10 + (float)notaXML.posicionX * 4 + recorrerCompases, -38 + notaCorregida, -1f), transform.rotation);
        //        objetoNota.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
        //        objetoNota.name = "" + notaXML.numMidi;
        //        objetoNota.tag = "NotaRedonda";
        //        objetoNota.transform.parent = transform;
        //        objetoNota.GetComponent<Renderer>().material = materialPentagrama;
        //        NotaRedonda cuadNota = objetoNota.GetComponent<NotaRedonda>();
        //        //wreckClone.transform.localScale = new Vector3(3, 3, 1);
        //        //cuadNota.id = i;
        //        cuadNota.id = notasCuantas;
        //        cuadNota.nota = notaCorregida;
        //        cuadNota.restBool = notaXML.rest;
        //        cuadNota.typeXML = notaXML.type;
        //        cuadNota.stem = notaXML.stem;
        //        cuadNota.simboloXML = notaXML.accidental;
        //        // Aqui va la información de sostenidos y todo eso
        //        cuadNota.tonalidadString = "Cm";
        //        cuadNota.indicePent = notaCorregida; // Esto se tiene que calcular en Tonalidad de acuerdo a el número midi
        //        // Poner el simbolo
        //        //cuadNota.simbolo = simboloPoner;

        //        // Los circulitos de seleccionado
        //        Vector3 pos = objetoNota.transform.GetChild(0).gameObject.transform.position;
        //        objetoNota.transform.GetChild(0).gameObject.transform.position = new Vector3(pos.x, pos.y, pos.z - 5.5f);

        //        objetoNota.transform.GetChild(0).gameObject.SetActive(false);
        //        objetoNota.gameObject.SetActive(true);
        //        cuadritosNotaList.Add(objetoNota);
        //        notasCuantas++;
        //    }
        //}


        //for (int i = 0; i < compasXMList.Count; i++)
        //{

        //    GameObject objArmadura = (GameObject)Instantiate(objCompas, new Vector3(10 + compasXMList[i].pxInic * 4 - 3, -1.91f, -1f), transform.rotation);
        //    // objArmadura.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
        //    objArmadura.name = "Compas " + i;
        //    objArmadura.GetComponent<CompasObjeto>().keyNum = compasXMList[i].keyNum;
        //    objArmadura.GetComponent<CompasObjeto>().beats = compasXMList[i].beats;
        //    objArmadura.GetComponent<CompasObjeto>().beatType = compasXMList[i].beatType;
        //    objArmadura.GetComponent<CompasObjeto>().setTodo();
        //    objArmadura.transform.parent = transform;
        //    barrasCompasLista.Add(objArmadura);
        //    // Crear lista de objeto de compases
        //}
        //Crear líneas de compases
        List<float> compasesL = objXML.GetComponent<XML_cargar>().posCompases;
        foreach (float compPx in compasesL)
        {
            GameObject barra = (GameObject)Instantiate(objBarraCompas, new Vector3(10 + compPx * 4 - 6, -1.91f, -1f), transform.rotation);
            barra.name = "Barra";
            barra.tag = "NotaRedonda";
            barra.transform.parent = transform;
            barrasCompasLista.Add(barra);
            // Crear una línea de compás
        }


        for (int i = 0; i < notasXMList.Count; i++)
        {
            // Debo corregir la altura XML
            n = notasXMList[i].numMidi;
            indice = univ.stringToEscala(mainDatos.tonalidadStr).indiceTabla(n);
            //float notaCorregida = float.Parse(indice.Split(',')[0]);
            float notaCorregida = notasXMList[i].indicePentagrama();
           // string simboloPoner = indice.Split(',')[1];
            //Debug.Log("ind: "+indice);
            GameObject objetoNota = (GameObject)Instantiate(objNota, new Vector3(10 + (float)notasXMList[i].posicionX * 4, -(7*5)-2+ notaCorregida, -1f), transform.rotation);
            objetoNota.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
            // Debo distinguir el numMidi del índice del pentagrama
            objetoNota.name = "" + notasXMList[i].numMidi;
            if (!notasXMList[i].rest)
            {
                objetoNota.tag = "NotaRedonda";
            }
            else
            {
                objetoNota.tag = "NotaSilencio";
            }
            objetoNota.transform.parent = transform;
            objetoNota.GetComponent<Renderer>().material = materialPentagrama;
            NotaRedonda cuadNota = objetoNota.GetComponent<NotaRedonda>();
            //wreckClone.transform.localScale = new Vector3(3, 3, 1);
            cuadNota.id = i;
            cuadNota.nota = notaCorregida;
            cuadNota.restBool = notasXMList[i].rest;
            cuadNota.typeXML = notasXMList[i].type;
            cuadNota.stem = notasXMList[i].stem;
            cuadNota.simboloXML = notasXMList[i].accidental;
            // Aqui va la información de sostenidos y todo eso
            cuadNota.tonalidadString = "Cm";
            cuadNota.indicePent = notaCorregida; // Esto se tiene que calcular en Tonalidad de acuerdo a el número midi
            // Poner el simbolo
            //cuadNota.simbolo = simboloPoner;

            // Los circulitos de seleccionado
            Vector3 pos = objetoNota.transform.GetChild(0).gameObject.transform.position;
            objetoNota.transform.GetChild(0).gameObject.transform.position = new Vector3(pos.x, pos.y, pos.z - 5.5f);

            objetoNota.transform.GetChild(0).gameObject.SetActive(false);
            objetoNota.gameObject.SetActive(true);
            cuadritosNotaList.Add(objetoNota);

        }

        // Recorrer las notas de acuerdo a los compases y armaduras que aparecen; (crear función)
        Debug.Log("Cuantos compases " + compasesCuantos);
        minNotas = cuadritosNotaList[0].transform.position.x;
        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        //Debug.Log("Min " + minNotas);
        //Debug.Log("Man " + maxNotas);
        objSliderPlay.GetComponent<SliderPlay>().cambiarEscala(minNotas, maxNotas);

        // COMPASES RECORRIDOS
        Vector3 posArm, posNota;
        float recorrerCompases=0, anchoTotal;
        //Debug.Log("Ciclo1" + barrasCompasLista.Count);
        //Debug.Log("Ciclo2" + cuadritosNotaList.Count);

        foreach(GameObject objArm in barrasCompasLista){
//            anchoTotal = objArm.GetComponent<CompasObjeto>().anchoTontal * 2;
            objArm.transform.position += new Vector3(recorrerCompases, 0f, 0f);
            posArm = objArm.transform.position;
            foreach (GameObject objNotas in cuadritosNotaList)
            {
                // Recorrer iterativamente los compases pasados
                posNota=objNotas.transform.position;
                if (posArm.x < posNota.x)
                {
                    //Debug.Log("Se recorrió " + anchoTotal);
                    //objNotas.transform.position += new Vector3(anchoTotal, 0f, 0f);
                }
            }
//            recorrerCompases += anchoTotal;
        }
            

    }

    public void recalcularModificadorNotaMIDI()
    {
        float posNx;
        string tonalidad = "CM";
        float n;
        string indice = "";

        for (int i = 0; i < cuadritosNotaList.Count; i++)
        {
            posNx = cuadritosNotaList[i].gameObject.transform.position.x;
            for (int k = 0; k < listTonalidadesObj.listTonalidades.Count; k++)
            {
                if (posNx > listTonalidadesObj.listTonalidades[k].transform.position.x)
                {
                    // Aqui se selecciona la última tonalidad que estuvo valida.
                    tonalidad = listTonalidadesObj.listTonalidades[k].GetComponent<TextMesh>().name;
                }
            }
            // El nombre de la nota es su altura musical
            n = float.Parse(cuadritosNotaList[i].name);
            // El indice es su línea de pentagrama
            indice = univ.stringToEscala(tonalidad).indiceTabla(n);
            float notaCorregida = float.Parse(indice.Split(',')[0]);
            string simboloPoner = indice.Split(',')[1];

            NotaRedonda cuadNota = cuadritosNotaList[i].GetComponent<NotaRedonda>();
            // Aqui hay un pedo... no debería cambiarse el identificador.
            //cuadNota.id = i;
            cuadNota.nota = notaCorregida;
            // Aqui va la información de sostenidos y todo eso
            cuadNota.tonalidadString = tonalidad;
            cuadNota.indicePent = notaCorregida; // Esto se tiene que calcular en Tonalidad de acuerdo a el número midi
            // Poner el simbolo
            cuadNota.simbolo = simboloPoner;
        }
        //        minNotas = cuadritosNotaList[0].transform.position.x;
        //        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        minNotas = cuadritosNotaList[0].transform.position.x;
        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        //Debug.Log("Min " + minNotas);
        //Debug.Log("Man " + maxNotas);
        objSliderPlay.GetComponent<SliderPlay>().cambiarEscala(minNotas, maxNotas);

    }

    public void moverCuadritosTonalidad(GameObject objTon, int sig)
    {
        float posNx;
        for (int i = 0; i < cuadritosNotaList.Count; i++)
        {
            posNx = cuadritosNotaList[i].transform.position.x;
            // Revisar si la tonalidad está antes o después de las tonalidades string
            if (posNx > objTon.transform.position.x)
            {
                cuadritosNotaList[i].gameObject.transform.position += new Vector3(15 * cuantoestirado * sig, 0, 0);
                //tonalidad = listTonalidades.listTonalidades[k].GetComponent<TextMesh>().text;
                // Se debe sumar de acuerdo a las tonalidades que están detrás de él
                //recorrerTonalidad += 20;
                //    cuantosAtras++;
            }
        }
        for (int j = 0; j < objEtiquetas.Count; j++)
        {
            posNx = objEtiquetas[j].transform.position.x;
            // Revisar si la tonalidad está antes o después de las tonalidades string
            if (posNx > objTon.transform.position.x)
            {
                objEtiquetas[j].transform.position += new Vector3(15 * cuantoestirado * sig, 0, 0);
            }
        }
        minNotas = cuadritosNotaList[0].transform.position.x;
        maxNotas = cuadritosNotaList[cuadritosNotaList.Count - 1].transform.position.x;
        //Debug.Log("Min " + minNotas);
        //Debug.Log("Man " + maxNotas);
        objSliderPlay.GetComponent<SliderPlay>().cambiarEscala(minNotas, maxNotas);
    }

    private void crearLineasPentagrama()
    {
        float valor;
        for (int i = 0; i < 120; i++)
        {
            if (i == 43 || i == 47 || i == 50 || i == 53
                || i == 57 || i == 64 || i == 67 || i == 71
                 || i == 74 || i == 77)
            {
                GameObject cube = GameObject.CreatePrimitive(PrimitiveType.Cube);
                //cube.AddComponent<Rigidbody>();
                //                valor = univ.stringToEscala("CM").indiceNota(i);
                valor = univ.stringToEscala("CM").indicePentagrama(i);
                cube.transform.position = new Vector3(0, -38 + valor, 1f);
                cube.GetComponent<Renderer>().material = materialPentagrama;
                cube.GetComponent<Renderer>().material.color = Color.black;
                cube.name = "" + i;
                cube.tag = "Pentagrama";
                cube.transform.parent = transform;
                cube.transform.localScale = new Vector3(100000, midi.transform.localScale.y / 2, midi.transform.localScale.z);
            }
        }
    }

    private void asignarColores()
    {
        if (cuadritosNotaList.Count > 0)
        {
            for (int i = 0; i < cuadritosNotaList.Count; i++)
            {
                // ROJO Default
                cuadritosNotaList[i].transform.GetChild(0).gameObject.SetActive(false);
                cuadritosNotaList[i].transform.GetChild(0).gameObject.GetComponent<Renderer>().material.color = Color.white;
                // Revisar si es un indice de la armonia actual
                for (int j = 0; j < cuadritosId.Count; j++)
                    if (cuadritosNotaList[i].GetComponent<NotaRedonda>().id == cuadritosId[j])
                    {
                        cuadritosNotaList[i].transform.GetChild(0).gameObject.SetActive(true);
                        cuadritosNotaList[i].transform.GetChild(0).gameObject.GetComponent<Renderer>().material.color = Color.blue;
                    }
            }
        }
    }
}

