﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class Armonia
{
    float fundamental = 0;
    public float Fundamental
    {
        get { return fundamental; }
        set { fundamental = value; }
    }

    public float[] notasArmonia;
    public List<float> notasSimplificadas;

    public float[] notasTipo;
    public string tipoDeAcordeStr = "*";
    public float inversion;
    public string inversionStr = "";
    private DefAcordesJazz defAc;
    bool isSeptimo = false;
    float restar;

    public Armonia()
    {
        // Debe poder existir la armonia vacia
        float[] arr = new float[0];
        defAc = new DefAcordesJazz();
        notasArmonia = new float[0];
        //this.fundamental = 0;
        ////		notasTipo = new float[notasArmonia.Length];
        //this.setSimplificado();
        //this.asignarIndiceLista();
        //this.setTipoVoces();
        //this.setInversion();
        //this.setInversionString();
    }
    public Armonia(List<float> notasL)
    {
        if (notasL.Count > 0)
        {
            float[] arr = new float[notasL.Count];
            for (int i = 0; i < notasL.Count; i++)
            {
                arr[i] = notasL[i];
            }
            System.Array.Sort(arr);

            defAc = new DefAcordesJazz();
            notasArmonia = (float[])arr.Clone();
            //		notasTipo = new float[notasArmonia.Length];
            this.setSimplificado();
            this.asignarIndiceLista();
            this.setTipoVoces();
            this.setInversion();
            this.setInversionString();
        }
    }

    public Armonia(float[] notasL)
    {

        //System.Array.Sort(notasL);
        //		for (int i=0; i<notasL.Length; i++) {
        //			Debug.Log (notasL[i]);
        //		}

        if (notasL.Length > 0)
        {
            defAc = new DefAcordesJazz();
            notasArmonia = notasL;
            //		notasTipo = new float[notasArmonia.Length];
            this.setSimplificado();
            this.asignarIndiceLista();
            this.setTipoVoces();
            this.setInversion();
            this.setInversionString();
        }
        else
        {
            //			notasArmonia = [0];
            //			notasTipo = [0];
        };

    }

    private void setSimplificado()
    {
        //float[] notasTemp = new float[notasArmonia.Length];
        // Mejor diferentes como Lista.}}
        float[] notasTemp = (float[])notasArmonia.Clone();
        //		Array.Clone(notasArmonia, notasTemp, notasArmonia.Length);
        List<float> diferentes = new List<float>();
        for (int i = 0; i < notasTemp.Length; i++)
        {
            notasTemp[i] = notasTemp[i] % 12;
        }
        //System.Array.Sort(notasTemp);

        // Quitar notas repetidas
        //ESTE NO SE POR QUE LO QUITE
        diferentes.Add(notasTemp[0]);
        for (int i = 1; i < notasTemp.Length; i++)
        {
            int condicion = 0;
            for (int j = 0; j < i; j++)
            {
                if (notasTemp[i] == notasTemp[j])
                {
                    condicion = 1;
                };
            }
            if (condicion == 0)
            {
                diferentes.Add(notasTemp[i]);
            }
        }
        notasSimplificadas = diferentes;
    }

    private bool perteneceEnLista(float[] acordeNotas)
    {
        bool cond = false;
        float[] tempA;
        if (notasSimplificadas.Count == acordeNotas.Length)
        {
            tempA = new float[notasSimplificadas.Count];
            for (int r = 0; r < notasSimplificadas.Count; r++)
            {
                restar = notasSimplificadas[r];
                for (int i = 0; i < tempA.Length; i++)
                {
                    // El modulo debe ser el de grupos
                    // no con negativos
                    tempA[i] = MatematicasOper.mod(notasSimplificadas[i] - restar, 12);
                }

                System.Array.Sort(tempA);
                if (tempA.SequenceEqual(acordeNotas))
                {
                    fundamental = MatematicasOper.mod(restar, 12);
                    cond = true;
                    // Quiza usar un while, para
                }
            }
        }
        ////////////////////7

        return cond;
    }

    private void asignarIndiceLista()
    {
        // Revisar si es igual a alguno de la librería
        //int i=0;
        for (int i = 0; i < defAc.arms.Count; i++)
        {
            if (this.perteneceEnLista(defAc.arms[i].notasDef))
            {
                tipoDeAcordeStr = defAc.arms[i].Nombre;
            }
        }
    }

    private void setTipoVoces()
    {
        float dist;
        notasTipo = new float[notasArmonia.Length];
        for (int i = 0; i < notasArmonia.Length; i++)
        {
            // float resta = (fundamental - notasArmonia[i]);
            dist = Math.Abs((fundamental - notasArmonia[i])) % 12;
            notasTipo[i] = this.intervaloDiatonico(dist);
            if (this.intervaloDiatonico(dist) == 7)
            {
                isSeptimo = true;
            }
        }
    }

    public float intervaloDiatonico(float dist)
    {
        float regresar = -1;
        switch ((int)dist)
        {
            case 0:
                regresar = 1;
                break;
            case 1:
                regresar = 2;
                break;
            case 2:
                regresar = 2;
                break;
            case 3:
                regresar = 3;
                break;
            case 4:
                regresar = 3;
                break;
            case 5:
                regresar = 5;
                break;
            case 6:
                regresar = 5;
                break;
            case 7:
                regresar = 5;
                break;
            case 8:
                regresar = 3;
                break;
            case 9:
                regresar = 3;
                break;
            case 10:
                regresar = 7;
                break;
            case 11:
                regresar = 7;
                break;
            default:
                break;
        }
        return regresar;
    }

    private void setInversion()
    {
        switch ((int)notasTipo[0])
        {
            case 1:
                inversion = 0;
                break;
            case 3:
                inversion = 1;
                break;
            case 5:
                inversion = 2;
                break;
            case 7:
                inversion = 3;
                break;
        }
    }

    private void setInversionString()
    {
        string invS = "";
        float inv = inversion;
        if (!isSeptimo)
        {
            if (inv == 1)
            {
                invS = invS + "6";
            };
            if (inv == 2)
            {
                invS = invS + "6,4";
            };
        }
        else
        {
            if (inv == 0)
            {
                invS = invS + "7";
            }
            if (inv == 1)
            {
                invS = invS + "6,5";
            }
            if (inv == 2)
            {
                invS = invS + "4,3";
            }
            if (inv == 3)
            {
                invS = invS + "2";
            }
        }
        inversionStr = invS;
    }

    public List<float[]> calcularIntervalos()
    {        
        List<float[]> intervs = new List<float[]>();
        //Debug.Log("_________________________________");
        //foreach (float i in notasSimplificadas)
        //{
        //    Debug.Log("NotasSimplificadas " + i);
        //}
        if (notasSimplificadas != null)
        {
            for (int i = 0; i < notasSimplificadas.Count; i++)
            {
                for (int j = 0; j < notasSimplificadas.Count; j++)
                {
                    //              intervs.Add(MatematicasOper.mod(notasArmonia[i] - notasArmonia[j], 12));
                    //Debug.Log("Primera nota " + notasArmonia[0] % 12);
                    //Debug.Log("Segunda nota " + notasArmonia[1] % 12);
                    //&& notasSimplificadas[i] < notasSimplificadas[j]
                    if (notasSimplificadas[i] % 12 != notasSimplificadas[j] % 12)
                    {
                        intervs.Add(new float[2] { notasSimplificadas[i] % 12, notasSimplificadas[j] % 12 });
                    }
                }
            }
        }
        //Debug.Log("_________________________________");
        //foreach (float[] i in intervs)
        //{
        //    Debug.Log("Acorde intervalo " + i[0] + " " + i[1]);
        //}
        return intervs; 
    }

    public bool equivalente(Armonia unArm)
    {
        bool cond = false;
        if (this.fundamental % 12 == unArm.fundamental % 12)
        {
            if (this.tipoDeAcordeStr.Equals(unArm.tipoDeAcordeStr))
            {
                cond = true;
            }
        }
        return cond;
    }

    public string fundamentalString()
    {
        string nota = "";
        // string acS = "";
        switch ((int)fundamental % 12)
        {
            case 0:
                nota = "C";
                break;
            case 1:
                nota = "C#";
                break;
            case 2:
                nota = "D";
                break;
            case 3:
                nota = "D#";
                break;
            case 4:
                nota = "E";
                break;
            case 5:
                nota = "F";
                break;
            case 6:
                nota = "F#";
                break;
            case 7:
                nota = "G";
                break;
            case 8:
                nota = "G#";
                break;
            case 9:
                nota = "A";
                break;
            case 10:
                nota = "A#";
                break;
            case 11:
                nota = "B";
                break;
        }
        return nota;
    }

    public void imprimir()
    {
        Debug.Log(fundamentalString() + " " + tipoDeAcordeStr + " " + inversionStr);
        string notas = "";
        for (int i = 0; i < notasArmonia.Length; i++)
        {
            notas = notas + " " + notasArmonia[i];
        }
        notas += " - ";
        for (int i = 0; i < notasArmonia.Length; i++)
        {
            notas = notas + " " + notasTipo[i];
        }
        Debug.Log(notas);
    }

    public void imprimriSencillo()
    {
        Debug.Log(fundamentalString() + "" + tipoDeAcordeStr + " " + inversionStr);
    }

    public string getStringSencillo()
    {
        string str = "" + fundamentalString() + "" + tipoDeAcordeStr + " " + inversionStr;
        return str;
    }
    public string getStringSencillo(Tonalidad ton)
    {
        string str = "" + ton.num2nota12(this.Fundamental) + "" + tipoDeAcordeStr + " " + inversionStr;
        return str;
    }

}
